/* -*- C++ -*-

  $Id: InsertPointCmd.h,v 1.3 1999/09/23 06:54:14 sattler Exp $

  This file is part of KIllustrator.
  Copyright (C) 1998 Kai-Uwe Sattler (kus@iti.cs.uni-magdeburg.de)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Library General Public License as
  published by  
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU Library General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef InsertPointCmd_h_
#define InsertPointCmd_h_

#include "GPolygon.h"
#include "Command.h"

class GDocument;
class GPolyline;

class InsertPointCmd : public Command {
public:
  InsertPointCmd (GDocument* doc, GPolyline* o, int idx,
		  float x, float y);

  ~InsertPointCmd ();

  void execute ();
  void unexecute ();

private:
  GDocument* document;
  GPolyline* obj;
  int index;
  Coord point;
  GPolygon::Kind kind;
};

#endif
